package tests;

import org.junit.*;
import static org.junit.Assert.*;
import topology.*;

public class TestComparablePair {

    ComparablePair<Integer,Integer> a = new ComparablePair(1,2);
    ComparablePair<Integer,Integer> b = new ComparablePair(1,3);
    ComparablePair<Integer,Integer> c = new ComparablePair(2,2);

    @Test
    public void testGetKey() {
	assertEquals((int)a.getKey(),1);
    }

    @Test
    public void testGetValue() {
	assertEquals((int)a.getValue(),2);
    }

    @Test
    public void testCompareTo() {
	int s = a.compareTo(b);
	int t = b.compareTo(a);
	int u = c.compareTo(b);
	int v = c.compareTo(a);
	assertEquals(s,-1);
	assertEquals(s,-t);
	assertTrue(t>0 && u>0 && v>0);
	assertTrue((a.compareTo(a)==0)==(a.equals(a)));
    }
}
