package tests;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;

import topology.*;
import homology.*;
import homology.f2homology.*;

public class TestF2 {

    F2 one = new F2(3);
    F2 zero = new F2(2);

    @Before
    public void setUp() {
    }
    
    @Test
    public void testGetNumber() {
	//Integer eins = 1;
	//Integer love = 0;
	assertEquals(one.getNumber(),1);
	assertEquals(zero.getNumber(),0);
    }

    @Test
    public void testAdd() {
	F2 a = one.add(one);
	F2 b = one.add(zero);
	F2 c = zero.add(one);
	F2 d = zero.add(zero);
	assertEquals(a.getNumber(),zero.getNumber());
	assertEquals(b.getNumber(),one.getNumber());
	assertEquals(c.getNumber(),one.getNumber());
	assertEquals(d.getNumber(),zero.getNumber());
    }

    @Test
    public void testEquals() {
	boolean a = one.equals(one);
	boolean b = one.equals(zero);
	boolean c = zero.equals(one);
	boolean d = zero.equals(zero);
	boolean e = zero.equals(0);
	F2 zeroPrime = new F2(0);
	boolean f = zeroPrime.equals(0);
	assertEquals(a,true);
	assertEquals(b,false);
	assertEquals(c,false);
	assertEquals(d,true);
	assertEquals(e,false);
	assertEquals(f,false);
    }

    @Test
    public void testMultiply() {
	F2 a = one.multiply(one);
	F2 b = one.multiply(zero);
	F2 c = zero.multiply(one);
	F2 d = zero.multiply(zero);
	assertEquals(a.equals(one),true);
	assertEquals(a.getNumber(),one.getNumber());
	assertEquals(b.equals(zero),true);
	assertEquals(c.equals(zero),true);
	assertEquals(c.equals(zero),true);
    }
    
    @After
    public void tearDown() {

    }
    

}
