package tests;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;

import topology.*;
import homology.*;
import homology.f2homology.*;

public class TestF2Matrix {

    List<F2[]> emptyList = new ArrayList();
    F2 one = new F2(1);
    F2 zero = new F2(0);
    F2Matrix<Integer,Integer> matrix = new F2Matrix<Integer,Integer>();
    TreeMap<ComparablePair<Integer,Integer>,F2> map = new TreeMap();
    F2Matrix matrix2 = new F2Matrix();
    TreeMap<ComparablePair<Integer,Integer>,F2> map2 = new TreeMap();
    F2Matrix matrix3 = new F2Matrix();
    TreeMap<ComparablePair<String,String>,F2> map3 = new TreeMap();
    F2Matrix product = new F2Matrix();
    TreeMap<ComparablePair<Integer,Integer>,F2> productMap = new TreeMap();
    Set<Integer> rowSet = new TreeSet();
    Set<Integer> columnSet = new TreeSet();
    F2[][] array = new F2[3][4];
    F2Matrix upperTriangular = new F2Matrix();
    TreeMap<ComparablePair<Integer,Integer>,F2> upperTriangMap = new TreeMap();
    F2[][] UArray = new F2[3][4];
    F2[][] rowEchelonArray = new F2[3][4];
    F2Matrix rowEchelon = new F2Matrix();
    TreeMap<ComparablePair<Integer,Integer>,F2> rEMap = new TreeMap();
    List<F2[]> readOffNF = new ArrayList();
    F2[] e1 = new F2[4];
    F2[] e2 = new F2[4];
    F2[] e3 = new F2[4];
    F2[] e4 = new F2[4];
    F2Vector standard1 = new F2Vector();
    F2Vector standard2 = new F2Vector();
    F2Vector standard3 = new F2Vector();
    F2Vector standard4 = new F2Vector();
    TreeMap<Integer,F2> standard1Map = new TreeMap();
    TreeMap<Integer,F2> standard2Map = new TreeMap();
    TreeMap<Integer,F2> standard3Map = new TreeMap();
    TreeMap<Integer,F2> standard4Map = new TreeMap();
    F2Matrix<Integer,Integer> emptyRowMatrix = new F2Matrix<Integer,Integer>();
    F2Matrix<Integer,Integer> emptyRowZeroMatrix = new F2Matrix<Integer,Integer>();
    F2Matrix<Integer,Integer> emptyColumnMatrix = new F2Matrix<Integer,Integer>();
    F2Matrix<Integer,Integer> emptyColumnZeroMatrix = new F2Matrix<Integer,Integer>();
    F2Matrix<Integer,Integer> emptyMatrix = new F2Matrix<Integer,Integer>();
    Set<Integer> columnSet0 = new TreeSet();
    Set<Integer> rowSet0 = new TreeSet();
    F2Matrix<Integer,Integer> emptyRCMatrix = new F2Matrix(rowSet0,columnSet0);
    F2[][] emptyRow = new F2[0][4];
    F2[][] emptyColumn = new F2[3][0];
    F2[][] empty = new F2[0][0];
    F2Matrix<Integer,Integer> zeroMatrix = new F2Matrix<Integer,Integer>();

    @Before
    public void setUp() {
	map.put(new ComparablePair(1,2),zero);
	map.put(new ComparablePair(1,4),one);
	map.put(new ComparablePair(2,1),one);
	map.put(new ComparablePair(2,3),one);
	map.put(new ComparablePair(3,1),one);
	map.put(new ComparablePair(3,4),one);
	matrix = new F2Matrix(map);

	map2.put(new ComparablePair(1,1),one);
	map2.put(new ComparablePair(1,2),one);
	map2.put(new ComparablePair(2,1),one);
	map2.put(new ComparablePair(2,3),one);
	matrix2 = new F2Matrix(map2);
	
	map3.put(new ComparablePair("1","2"),zero);
	map3.put(new ComparablePair("1","3"),zero);
	map3.put(new ComparablePair("1","4"),one);
	map3.put(new ComparablePair("2","1"),one);
	map3.put(new ComparablePair("2","3"),one);
	map3.put(new ComparablePair("3","1"),one);
	map3.put(new ComparablePair("3","4"),one);
	matrix3 = new F2Matrix(map3);

	productMap.put(new ComparablePair(1,1),one);
	productMap.put(new ComparablePair(1,2),zero);
	productMap.put(new ComparablePair(1,3),one);
	productMap.put(new ComparablePair(1,4),one);
	productMap.put(new ComparablePair(2,1),one);
	product = new F2Matrix(productMap);

	emptyRowZeroMatrix = new F2Matrix(rowSet0,columnSet,zero);
	emptyRowMatrix = new F2Matrix(rowSet0,columnSet);
	rowSet.addAll(Arrays.asList(1,2,3));
	columnSet.addAll(Arrays.asList(1,2,3,4));
	emptyColumnZeroMatrix = new F2Matrix(rowSet,columnSet0,zero);
	emptyColumnMatrix = new F2Matrix(rowSet,columnSet0);
	emptyMatrix = new F2Matrix(rowSet,columnSet);
	zeroMatrix = new F2Matrix(rowSet,columnSet,zero);

	array[0][0] = zero;
	array[0][1] = zero;
	array[0][2] = zero;
	array[0][3] = one;
	array[1][0] = one;
	array[1][1] = zero;
	array[1][2] = one;
	array[1][3] = zero; 
	array[2][0] = one;
	array[2][1] = zero;
	array[2][2] = zero;
	array[2][3] = one;
	
	upperTriangMap.put(new ComparablePair(1,1),one);
	upperTriangMap.put(new ComparablePair(1,2),zero);
	upperTriangMap.put(new ComparablePair(1,3),one);
	upperTriangMap.put(new ComparablePair(2,3),one);
	upperTriangMap.put(new ComparablePair(2,4),one);
	upperTriangMap.put(new ComparablePair(3,4),one);
	upperTriangular = new F2Matrix(upperTriangMap); 

	UArray[0][0]=one; UArray[0][1]=zero; UArray[0][2]=one; UArray[0][3]=zero;
	UArray[1][0]=zero; UArray[1][1]=zero; UArray[1][2]=one; UArray[1][3]=one;
	UArray[2][0]=zero; UArray[2][1]=zero; UArray[2][2]=zero; UArray[2][3]=one;

	rowEchelonArray[0][0] = one; 
	rowEchelonArray[0][1] = zero;
	rowEchelonArray[0][2] = zero;
	rowEchelonArray[0][3] = zero;
	rowEchelonArray[1][0] = zero;
	rowEchelonArray[1][1] = zero;
	rowEchelonArray[1][2] = one;
	rowEchelonArray[1][3] = zero;
	rowEchelonArray[2][0] = zero;
	rowEchelonArray[2][1] = zero;
	rowEchelonArray[2][2] = zero;
	rowEchelonArray[2][3] = one;

	rEMap.put(new ComparablePair(1,1),one);
	rEMap.put(new ComparablePair(1,2),zero);
	rEMap.put(new ComparablePair(2,3),one);
	rEMap.put(new ComparablePair(3,4),one);
	rowEchelon = new F2Matrix(rEMap);

	e1[0] = one; e1[1] = zero; e1[2] = zero; e1[3] = zero;
	e2[0] = zero; e2[1] = one; e2[2] = zero; e2[3] = zero;
	e3[0] = zero; e3[1] = zero; e3[2] = one; e3[3] = zero;
	e4[0] = zero; e4[1] = zero; e4[2] = zero; e4[3] = one;
	readOffNF.add(e1);
	readOffNF.add(e2);
	readOffNF.add(e3);
	readOffNF.add(e4);

	standard1Map.put(1,one);
	standard1Map.put(2,zero);
	standard1Map.put(3,zero);
	standard1Map.put(4,zero);
	standard1 = new F2Vector(standard1Map);

	standard2Map.put(1,zero);
	standard2Map.put(2,one);
	standard2Map.put(3,zero);
	standard2Map.put(4,zero);
	standard2 = new F2Vector(standard2Map);

	standard3Map.put(1,zero);
	standard3Map.put(2,zero);
	standard3Map.put(3,one);
	standard3Map.put(4,zero);
	standard3 = new F2Vector(standard3Map);

	standard4Map.put(1,zero);
	standard4Map.put(2,zero);
	standard4Map.put(3,zero);
	standard4Map.put(4,one);
	standard4 = new F2Vector(standard4Map);
    }
    
    @Test
    public void testRows() {
	assertEquals(matrix.rows(),rowSet);
	//for (Integer i : matrix.rows()) {
	//   System.out.println(i);
	//}
    }

    @Test
    public void testColumns() {
	assertEquals(matrix.columns(),columnSet);
    }

    @Test
    public void testRowList() {
	List<Integer> rowList = new ArrayList();
	rowList.add(1);
	rowList.add(2);
	rowList.add(3);
	assertEquals(matrix.rowList(),rowList);
    }
    
    @Test
    public void testColumnList() {
	List<Integer> columnList = new ArrayList();
	columnList.add(1);
	columnList.add(2);
	columnList.add(3);
	columnList.add(4);
	for (int i = 0; i < 4; i++) {
	    assertEquals(matrix.columnList().get(i),columnList.get(i));
	}
    }

    @Test
    public void testToArray() {
	F2[][] emptyRowToArray = emptyRowMatrix.toArray();
	F2[][] emptyRowZeroToArray = emptyRowZeroMatrix.toArray();
	assertEquals(emptyRowToArray,emptyRow);
	assertEquals(emptyRowZeroToArray,emptyRow);
	F2[][] emptyColumnToArray = emptyColumnMatrix.toArray();
	F2[][] emptyColumnZeroToArray = emptyColumnZeroMatrix.toArray();
	assertEquals(emptyColumnToArray,emptyColumn);
	assertEquals(emptyColumnZeroToArray,emptyColumn);
	F2[][] emptyRCToArray = emptyRCMatrix.toArray();
	assertEquals(emptyRCToArray,empty);
	F2[][] emptyToArray = emptyMatrix.toArray();
	boolean[][] equal = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal[i][j] = emptyToArray[i][j].equals(zero);
		assertEquals(equal[i][j],true);
	    }
	}
	F2[][] toArray = matrix.toArray();
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal[i][j] = toArray[i][j].equals(array[i][j]);
		assertEquals(equal[i][j],true);
	    }
	}
    }

    @Test
    public void testUpperTriangArray() {
	F2[][] emptyRowU = emptyRowMatrix.upperTriangArray();
	F2[][] emptyRowZeroU = emptyRowZeroMatrix.upperTriangArray();
	assertEquals(emptyRowU,emptyRow);
	assertEquals(emptyRowZeroU,emptyRow);
	F2[][] emptyColumnU = emptyColumnMatrix.upperTriangArray();
	F2[][] emptyColumnZeroU = emptyColumnZeroMatrix.upperTriangArray();
	assertEquals(emptyColumnU,emptyColumn);
	assertEquals(emptyColumnZeroU,emptyColumn);
	F2[][] emptyRCU = emptyRCMatrix.upperTriangArray();
	assertEquals(emptyRCU,empty);
	F2[][] emptyU = emptyMatrix.upperTriangArray();
	boolean[][] equal = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal[i][j] = emptyU[i][j].equals(zero);
		assertEquals(equal[i][j],true);
	    }
	}
	F2[][] U = new F2[3][4];
	U = matrix.upperTriangArray();
	boolean[][] equal1 = new boolean[3][4];
	boolean[][] equal2 = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal1[i][j] = U[i][j].equals(UArray[i][j]);
		equal2[i][j] = true;
	    }
	}
	assertEquals(equal1,equal2);
    }
    
    @Test
    public void testUpperTriangular() {
	F2Matrix emptyRowU = emptyRowMatrix.upperTriangular();
	assertEquals(emptyRowU,emptyRowMatrix);
	F2Matrix emptyRowZeroU = emptyRowZeroMatrix.upperTriangular();
	assertEquals(emptyRowZeroU,emptyRowZeroMatrix);
	F2Matrix emptyColumnU = emptyColumnMatrix.upperTriangular();
	assertEquals(emptyColumnU,emptyColumnMatrix);
	F2Matrix emptyColumnZeroU = emptyColumnZeroMatrix.upperTriangular();
	assertEquals(emptyColumnZeroU,emptyColumnZeroMatrix);
	F2Matrix emptyRCU = emptyRCMatrix.upperTriangular();
	assertEquals(emptyRCU,emptyRCMatrix);
	F2Matrix emptyU = emptyMatrix.upperTriangular();
	assertEquals(emptyU.equals(zeroMatrix),true);
	F2Matrix U = matrix.upperTriangular();
	boolean[][] equal1 = new boolean[3][4];
	boolean[][] equal2 = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal1[i][j] = U.toArray()[i][j]
		    .equals(upperTriangular.toArray()[i][j]);
		equal2[i][j] = true;
	    }
	}
	assertEquals(equal1,equal2);
    }

    @Test
    public void testRowEchelonArray() {
	F2[][] emptyRowE = emptyRowMatrix.rowEchelonArray();
	assertEquals(emptyRowE,emptyRow);
	F2[][] emptyRowZeroE = emptyRowZeroMatrix.rowEchelonArray();
	assertEquals(emptyRowZeroE,emptyRow);
	F2[][] emptyColumnE = emptyColumnMatrix.rowEchelonArray();
	assertEquals(emptyColumnE,emptyColumn);
	F2[][] emptyColumnZeroE = emptyColumnZeroMatrix.rowEchelonArray();
	assertEquals(emptyColumnZeroE,emptyColumn);
	F2[][] emptyRCE = emptyRCMatrix.rowEchelonArray();
	assertEquals(emptyRCE,empty);
	F2[][] emptyE = emptyMatrix.rowEchelonArray();
	boolean[][] equal = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal[i][j] = emptyE[i][j].equals(zero);
		assertEquals(equal[i][j],true);
	    }
	}
	F2[][] E = matrix.rowEchelonArray();
	boolean[][] equal1 = new boolean[3][4];
	boolean[][] equal2 = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal1[i][j] = E[i][j].equals(rowEchelonArray[i][j]);
		equal2[i][j] = true;
	    }
	}
	assertEquals(equal1,equal2);
    }
    
    @Test
    public void testRowEchelon() {
	F2Matrix emptyRowE = emptyRowMatrix.rowEchelon();
	assertEquals(emptyRowE,emptyRowMatrix);
	F2Matrix emptyRowZeroE = emptyRowZeroMatrix.rowEchelon();
	assertEquals(emptyRowZeroE,emptyRowZeroMatrix);
	F2Matrix emptyColumnE = emptyColumnMatrix.rowEchelon();
	assertEquals(emptyColumnE,emptyColumnMatrix);
	F2Matrix emptyColumnZeroE = emptyColumnZeroMatrix.rowEchelon();
	assertEquals(emptyColumnZeroE,emptyColumnZeroMatrix);
	F2Matrix emptyRCE = emptyRCMatrix.rowEchelon();
	assertEquals(emptyRCE,emptyRCMatrix);
	F2Matrix emptyE = emptyMatrix.rowEchelon();
	assertEquals(emptyE.equals(zeroMatrix),true);
	F2Matrix E = matrix.rowEchelon();
	boolean[][] equal1 = new boolean[3][4];
	boolean[][] equal2 = new boolean[3][4];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 4; j++) {
		equal1[i][j] = E.toArray()[i][j]
		    .equals(rowEchelon.toArray()[i][j]);
		equal2[i][j] = true;
	    }
	}
	assertEquals(equal1,equal2);
    }

    @Test 
    public void testReadOffNF() {
	List<F2[]> R = matrix.readOffNF();
	//System.out.println(R.size());
       	//System.out.println(R.get(0).length);
       	boolean[][] equal1 = new boolean[4][4];
	boolean[][] equal2 = new boolean[4][4];
	for (int i = 0; i < 4; i++) {
	    for (int j = 0; j < 4; j++){
		equal1[i][j] = R.get(i)[j].equals(readOffNF.get(i)[j]);
		equal2[i][j] = true;
	    }
	}
	assertEquals(equal1,equal2);
    }
    
    @Test
    public void testKernelBasisListOfArray() {
	List<F2[]> emptyRowK = emptyRowMatrix.kernelBasisListOfArray();
	for (int i = 0; i < 4; i++) {
	    assertEquals(emptyRowK.get(0)[i].equals(e1[i]),true);
	    assertEquals(emptyRowK.get(1)[i].equals(e2[i]),true);
	    assertEquals(emptyRowK.get(2)[i].equals(e3[i]),true);
	    assertEquals(emptyRowK.get(3)[i].equals(e4[i]),true);
	}
	List<F2[]> emptyColumnK = emptyColumnMatrix.kernelBasisListOfArray();
	assertEquals(emptyColumnK,emptyList);
	List<F2[]> emptyRCK = emptyRCMatrix.kernelBasisListOfArray();
	assertEquals(emptyRCK,emptyList);
	List<F2[]> K = matrix.kernelBasisListOfArray();
	boolean[] equal1 = new boolean[4];
	boolean[] equal2 = new boolean[4];
	for (int i = 0; i < 4; i++) {
	    equal1[i] = K.get(0)[i].equals(e2[i]);
	    equal2[i] = true;
	    assertEquals(equal1[i],equal2[i]);
	}

    }

    @Test
    public void testKernelBasis() {
	List<F2Vector<Integer>> emptyRowK = emptyRowMatrix.kernelBasis();
	assertEquals(emptyRowK.get(0).equals(standard1),true);
	assertTrue(emptyRowK.get(1).equals(standard2));
	assertTrue(emptyRowK.get(2).equals(standard3));
	assertTrue(emptyRowK.get(3).equals(standard4));
	List<F2Vector<Integer>> emptyColumnK = emptyColumnMatrix.kernelBasis();
	assertEquals(emptyColumnK,emptyList);
	List<F2Vector<Integer>> emptyRCK = emptyRCMatrix.kernelBasis();
	assertEquals(emptyRCK,emptyList);
	List<F2Vector<Integer>> K = matrix.kernelBasis();
	boolean[] equal1 = new boolean[4];
	boolean[] equal2 = new boolean[4];
	for (int i = 0; i < 4; i++) {
	    equal1[i] = K.get(0).toArray()[i].equals(standard2.toArray()[i]);
	    equal2[i] = true;
	    assertEquals(equal1[i],equal2[i]);
	}
    }

    @Test
    public void testImageBasisListOfArray() {
	List<F2[]> emptyRowI = emptyRowMatrix.imageBasisListOfArray();
	assertEquals(emptyRowI,emptyList);
	List<F2[]> emptyColumnI = emptyColumnMatrix.imageBasisListOfArray();
	assertEquals(emptyColumnI,emptyList);
	List<F2[]> emptyRCI = emptyRCMatrix.imageBasisListOfArray();
	assertEquals(emptyRCI,emptyList);
	List<F2[]> I = matrix.imageBasisListOfArray();
	List<F2[]> imageBasis = new ArrayList();
	F2[] basis1 = new F2[3];
	F2[] basis2 = new F2[3];
	F2[] basis3 = new F2[3];
	basis1[0] = zero; basis1[1] = one; basis1[2] = one;
	basis2[0] = zero; basis2[1] = one; basis2[2] = zero;
	basis3[0] = one; basis3[1] = zero; basis3[2] = one;
	boolean[][] equal1 =  new boolean[3][3];
	boolean[][] equal2 =  new boolean[3][3];
	imageBasis.add(basis1); imageBasis.add(basis2); imageBasis.add(basis3);
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 3; j++) {
		equal1[i][j] = I.get(i)[j].equals(imageBasis.get(i)[j]);
		equal2[i][j] = true;
		assertEquals(equal1[i][j],equal2[i][j]);
	    }
	}
    }

    @Test
    public void testImageBasis() {
	List<F2Vector<Integer>> emptyRowI = emptyRowMatrix.imageBasis();
	assertEquals(emptyRowI,emptyList);
	List<F2Vector<Integer>> emptyColumnI = emptyColumnMatrix.imageBasis();
	assertEquals(emptyColumnI,emptyList);
	List<F2Vector<Integer>> emptyRCI = emptyRCMatrix.imageBasis();
	assertEquals(emptyRCI,emptyList);
	List<F2Vector<Integer>> I = matrix.imageBasis();
	List<F2Vector<Integer>> imageBasis = new ArrayList();
	F2Vector<Integer> basis1 = new F2Vector();
	F2Vector<Integer> basis2 = new F2Vector();
	F2Vector<Integer> basis3 = new F2Vector();
	TreeMap<Integer,F2> map1 = new TreeMap();
	TreeMap<Integer,F2> map2 = new TreeMap();
	TreeMap<Integer,F2> map3 = new TreeMap();
	map1.put(1,zero); map1.put(2,one); map1.put(3,one); 
	basis1 = new F2Vector(map1);
	map2.put(1,zero); map2.put(2,one); map2.put(3,zero);
	basis2 = new F2Vector(map2);
	map3.put(1,one); map3.put(2,zero); map3.put(3,one);
	basis3 = new F2Vector(map3);
	imageBasis.add(basis1); imageBasis.add(basis2); imageBasis.add(basis3);
	boolean[][] equal1 = new boolean[3][3];
	boolean[][] equal2 = new boolean[3][3];
	for (int i = 0; i < 3; i++) {
	    for (int j = 0; j < 3; j++) {
		equal1[i][j] = I.get(i).toArray()[j]
		    .equals(imageBasis.get(i).toArray()[j]);
		equal2[i][j] = true;
		assertEquals(equal1[i][j],equal2[i][j]);
	    }
	}
    }

    @Test
    public void testProduct() {
	F2Matrix<Integer,Integer> emptyMatrix2 = new F2Matrix(columnSet,columnSet);
	F2Matrix A = emptyRowMatrix.product(emptyMatrix2);
	assertEquals(A,emptyRowMatrix);
	F2Matrix<Integer,Integer> emptyMatrix3 = new F2Matrix(rowSet,rowSet);
	F2Matrix B = emptyMatrix3.product(emptyColumnMatrix);
	assertEquals(B,emptyColumnMatrix);
	F2Matrix C = emptyRCMatrix.product(emptyRowMatrix);
	assertEquals(C,emptyRowMatrix);
	F2Matrix D = emptyColumnMatrix.product(emptyRCMatrix);
	assertEquals(D,emptyColumnMatrix);
	F2Matrix P = matrix2.product(matrix);
	boolean[][] equal1 = new boolean[2][4];
	boolean[][] equal2 = new boolean[2][4];
	for (int i = 0; i < 2; i++) {
	    for (int j = 0; j < 4; j++) {
		equal1[i][j] = P.toArray()[i][j]
		    .equals(product.toArray()[i][j]);
		equal2[i][j] = true;
		assertEquals(equal1[i][j],equal2[i][j]);
	    }
	}
    }

    @Test
    public void testEquals() {
	assertEquals(matrix.equals(matrix),true);
	assertEquals(matrix.equals(matrix2),false);
	assertEquals(emptyRowMatrix.equals(emptyRowZeroMatrix),true);
	assertEquals(emptyColumnMatrix.equals(emptyColumnZeroMatrix),true);
	assertEquals(emptyMatrix.equals(zeroMatrix),false);
	assertEquals(emptyMatrix.equals(emptyMatrix),true);
	assertEquals(emptyRCMatrix.equals(emptyRCMatrix),true);
	assertEquals(emptyRCMatrix.equals(emptyMatrix),false);
    }

    @Test 
    public void testEqualArray() {
	assertEquals(matrix.equalArray(matrix),true);
	assertEquals(matrix.equalArray(matrix3),true);
    }

    @After
    public void tearDown() {

    }
    

}
