package tests;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;

import topology.*;
import homology.*;
import homology.f2homology.*;

public class TestF2Vector {

    F2 one = new F2(1);
    F2 zero = new F2(0);
    F2Vector vector = new F2Vector();
    TreeMap<Integer,F2> map = new TreeMap();
    TreeMap<String,F2> map2 = new TreeMap();
    F2Vector vector2 = new F2Vector();
    F2Vector vector3 = new F2Vector();
    TreeMap<ComparablePair<Integer,Integer>,F2> map3 = new TreeMap();

    @Before
    public void setUp() {
	map.put(1,one);
	map.put(2,zero);
	map.put(3,null);
	vector = new F2Vector(map);

	map2.put("a", one);
	map2.put("abe",zero);
	map2.put("aber",null);
	vector2 = new F2Vector(map2);

	map3.put(new ComparablePair(1,1),one);
	map3.put(new ComparablePair(1,2),zero);
	map3.put(new ComparablePair(2,2),null);
	vector3 = new F2Vector(map3);
    }
    
    @Test
    public void testToArray() {
	F2[] array1 = vector.toArray();
	F2[] array2 = new F2[3];
	array2[0] = one;
	array2[1] = zero;
	array2[2] = zero;
	boolean[] equal = new boolean[3];
	for (int i = 0; i<3; i++){
	    equal[i] = array1[i].equals(array2[i]);
	    assertEquals(equal[i],true);
	}
    }

    @Test
    public void testToArray2() {
	F2[] array1 = vector2.toArray();
	F2[] array2 = vector.toArray();
	boolean[] equal = new boolean[3];
	for (int i = 0; i < 3; i++) {
	    equal[i] = array1[i].equals(array2[i]);
	    assertEquals(equal[i],true);
	}
    }

    @Test
    public void testToArray3() {
	F2[] array1 = vector3.toArray();
	F2[] array2 = vector.toArray();
	boolean[] equal = new boolean[3];
	for (int i = 0; i < 3; i++) {
	    equal[i] = array1[i].equals(array2[i]);
	    assertEquals(equal[i],true);
	}
    }

    @Test
    public void testLength() {
	assertEquals(vector.length(),3);
    }

    @Test
    public void testEquals() {
	assertEquals(vector.equals(vector),true);
	assertEquals(vector.equals(vector2),false);
    }
    
    @After
    public void tearDown() {

    }
    

}
