package tests;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;
import topology.*;

public class TestFiniteSpace {
    
    Set<Integer> myPointSet = new TreeSet();
    BinaryRelation<Integer> myRelation = new BinaryRelation();
    FiniteSpace<Integer> mySpace = new FiniteSpace();
    FiniteSpace<Integer> yourSpace = new FiniteSpace();
    BinaryRelation<Integer> myPreOrder = new BinaryRelation();
    BinaryRelation<Integer> yourRelation = new BinaryRelation();
    FiniteSpace<Integer> ourSpace = new FiniteSpace();
    BinaryRelation<Integer> ourRelation = new BinaryRelation();
    BinaryRelation<Integer> ourPreOrder = new BinaryRelation();
    Set<String> aPointSet = new TreeSet();
    BinaryRelation<String> aRelation = new BinaryRelation();
    FiniteSpace<String> aSpace = new FiniteSpace();
    FiniteSpace<Integer> someSpace = TopologyExamples.someSpace();
    FiniteSpace<Integer> someSpace2 = new FiniteSpace();
    Set<Integer> somePointSet2 = new TreeSet();
    BinaryRelation<Integer> someRelation2 = new BinaryRelation();
    FiniteSpace<Integer> someSpace3 = new FiniteSpace();
    Set<Integer> somePointSet3 = new TreeSet();
    BinaryRelation<Integer> someRelation3 = new BinaryRelation();

    FiniteSpace<Integer> wallet = TopologyExamples.wallet();
    FiniteSpace<Integer> U3Hat = wallet.pNeighbourhood(3);
    FiniteSpace<Integer> U3HatPrime = new FiniteSpace();
    Set<Integer> U3HatPrimePointSet = new TreeSet();
    BinaryRelation<Integer> emptyRelation = new BinaryRelation();

    @Before
    public void setUp() {
	somePointSet3.addAll(Arrays.asList(1,4,5));
	someSpace3 = new FiniteSpace(somePointSet3,someRelation3);
	someSpace3.addPair(new ComparablePair(1,4));
	someSpace3.addPair(new ComparablePair(4,5));
	someSpace3.addPair(new ComparablePair(1,1));
	
	somePointSet2.addAll(Arrays.asList(1,2,4,5));
	someSpace2 = new FiniteSpace(somePointSet2,someRelation2);
	someSpace2.addPair(new ComparablePair(1,2));
	someSpace2.addPair(new ComparablePair(2,1));
	someSpace2.addPair(new ComparablePair(2,4));
	someSpace2.addPair(new ComparablePair(4,5));
	
	myPointSet.addAll(Arrays.asList(1,2,3,4,5));

	mySpace = new FiniteSpace(myPointSet,myRelation);
	mySpace.addPair(new ComparablePair(1,2));
	mySpace.addPair(new ComparablePair(1,3));
	mySpace.addPair(new ComparablePair(2,4));
	mySpace.addPair(new ComparablePair(2,5));
	mySpace.addPair(new ComparablePair(3,4));
	mySpace.addPair(new ComparablePair(3,5));

	yourSpace = new FiniteSpace(myPointSet,myRelation);
	//ourSpace = new FiniteSpace(myPointSet,myRelation);

	myRelation.add(new ComparablePair(1,2));
	myRelation.add(new ComparablePair(1,3));
	myRelation.add(new ComparablePair(2,4));
	myRelation.add(new ComparablePair(2,5));
	myRelation.add(new ComparablePair(3,4));
	myRelation.add(new ComparablePair(3,5));

	myPreOrder.addAll(myRelation.getPairs());
	myPreOrder.add(new ComparablePair(1,1));
	myPreOrder.add(new ComparablePair(2,2));
	myPreOrder.add(new ComparablePair(3,3));
	myPreOrder.add(new ComparablePair(4,4));
	myPreOrder.add(new ComparablePair(5,5));
	myPreOrder.add(new ComparablePair(1,4));
	myPreOrder.add(new ComparablePair(1,5));

	yourRelation.addAll(myRelation.getPairs());
	yourRelation.remove(new ComparablePair(1,2));
	yourRelation.remove(new ComparablePair(2,4));
	yourRelation.remove(new ComparablePair(2,5));
	yourRelation.add(new ComparablePair(1,4));
	yourRelation.add(new ComparablePair(1,5));
	//yourSpace = new FiniteSpace(myPointSet,yourRelation);

	ourRelation.add(new ComparablePair(1,2));
	ourRelation.add(new ComparablePair(2,3));
	ourRelation.add(new ComparablePair(3,1));
	ourRelation.add(new ComparablePair(3,4));
	ourRelation.add(new ComparablePair(4,5));
	ourSpace = new FiniteSpace(myPointSet,ourRelation);
	
	ourPreOrder.addAll(ourRelation.getPairs());
	ourPreOrder.add(new ComparablePair(1,1));
	ourPreOrder.add(new ComparablePair(2,2));
	ourPreOrder.add(new ComparablePair(3,3));
	ourPreOrder.add(new ComparablePair(4,4));
	ourPreOrder.add(new ComparablePair(5,5));
	ourPreOrder.add(new ComparablePair(1,3));
	ourPreOrder.add(new ComparablePair(1,4));
	ourPreOrder.add(new ComparablePair(1,5));
	ourPreOrder.add(new ComparablePair(2,1));
	ourPreOrder.add(new ComparablePair(2,4));
	ourPreOrder.add(new ComparablePair(2,5));
	ourPreOrder.add(new ComparablePair(3,2));
	ourPreOrder.add(new ComparablePair(3,5));

	aPointSet.addAll(Arrays.asList("a","b","c","d"));
	aRelation.add(new ComparablePair("a","c"));
	aRelation.add(new ComparablePair("a","d"));
	aRelation.add(new ComparablePair("b","c"));
	aRelation.add(new ComparablePair("b","d"));
	aSpace = new FiniteSpace(aPointSet,aRelation);

	U3HatPrimePointSet.addAll(Arrays.asList(6,8,9,10,11));
	U3HatPrime = new FiniteSpace(U3HatPrimePointSet,emptyRelation);
	U3HatPrime.addPair(new ComparablePair(6,9));
	U3HatPrime.addPair(new ComparablePair(6,10));
	U3HatPrime.addPair(new ComparablePair(8,10));
	U3HatPrime.addPair(new ComparablePair(8,11));

    }
    
    @Test
    public void testConstructor() {
	myRelation.add(new ComparablePair(1,7));
	myRelation.add(new ComparablePair(8,2));
	myRelation.add(new ComparablePair(9,9));
	FiniteSpace<Integer> constructedSpace = new FiniteSpace(myPointSet,
								myRelation);
	assertEquals(mySpace.getPointSet(),constructedSpace.getPointSet());
	assertEquals(mySpace.getRelation().getPairs(),
		     constructedSpace.getRelation().getPairs());
    }

    @Test
    public void testGetPointSet() {
	assertEquals(mySpace.getPointSet(), myPointSet);
    }

    @Test
    public void testGetRelation() {
	assertEquals(mySpace.getRelation().getPairs(),myRelation.getPairs());
	FiniteSpace<Integer> theirSpace 
	    = new FiniteSpace(myPointSet,myRelation);
	assertEquals(mySpace.getRelation().getPairs(),
		     theirSpace.getRelation().getPairs());
    }

    @Test
    public void testGetPreOrder() {
	assertEquals(mySpace.getPreOrder().getPairs(),myPreOrder.getPairs());
	assertEquals(ourPreOrder.getPairs(),
		     TopologyExamples.someSpace().getPreOrder().getPairs());
    }

    @Test
    public void testIsTzero() {
	assertEquals(mySpace.isTzero(),true);
	mySpace.addPair(new ComparablePair(4,1));
	assertEquals(mySpace.isTzero(),false);
    }

    @Test
    public void testAddPair() {
	assertEquals(mySpace.addPair(new ComparablePair(1,6)),false);
    }

    @Test
    public void testRemovePoint() {
	mySpace.removePoint(2);
	assertEquals(mySpace.getRelation().getPairs(),yourRelation.getPairs());
	someSpace.removePoint(3);
	assertEquals(someSpace.getRelation().getPairs(),
		     someSpace2.getRelation().getPairs());
	someSpace2.removePoint(2);
	BinaryRelation relation = someSpace2.getRelation();
	assertEquals(someSpace2.getRelation().getPairs(),
		     someSpace3.getRelation().getPairs());
    }

    @Test
    public void testAddAllPair() {
	yourSpace.addAllPair(myRelation.getPairs());
	assertEquals(mySpace.getRelation().getPairs(),
		     yourSpace.getRelation().getPairs());
    }

    @Test
    public void testRemoveAllPoint() {
	Set<Integer> aSet = new TreeSet(Arrays.asList(2,3,4,5));
	mySpace.removeAllPoint(aSet);
	yourSpace.removeAllPoint(aSet);
	assertEquals(mySpace.getPointSet(),yourSpace.getPointSet());

	Set<Integer> bSet = new TreeSet(Arrays.asList(2,3));
	someSpace.removeAllPoint(bSet);
	assertEquals(someSpace.getPointSet(),someSpace3.getPointSet());
	assertEquals(someSpace.getRelation().getPairs(),
		     someSpace3.getRelation().getPairs());
    }

   
    @Test
    public void testAllPaths() {
	Integer one = new Integer(1);
	Integer two =  new Integer(2);
	Integer three = new Integer(3);
	Integer four = new Integer(4);
	Integer five = new Integer(5);
	Set<List<Integer>> myPaths = mySpace.allPaths(one,four);
	assertEquals(myPaths.isEmpty(),false);

	List<Integer> myPath = new ArrayList<Integer>();
	myPath.addAll(Arrays.asList(1,3,4));
	assertEquals(myPaths.contains(myPath),true);
	
	yourSpace.removeAllPair(myRelation.getPairs());
	yourSpace.addAllPair(yourRelation.getPairs());
	Set<List<Integer>> yourPaths = yourSpace.allPaths(one,five);
	assertEquals(yourPaths.isEmpty(),false);
	
	List<Integer> yourPath = new ArrayList<Integer>();
	yourPath.addAll(Arrays.asList(1,3,5));
       	assertEquals(yourPaths.contains(yourPath),true);

	List<Integer> yourPath2 = new ArrayList<Integer>();
	yourPath2.addAll(Arrays.asList(1,5));
	assertEquals(yourPaths.contains(yourPath2),true);
	//System.out.println(yourPaths);

    }

    @Test
    public void testFatPoints() {
	Set<TreeSet<Integer>> fatPoints = someSpace.fatPoints();
	//System.out.println(fatPoints);
	TreeSet<Integer> fatPoint = new TreeSet();
	fatPoint.addAll(Arrays.asList(1,2,3));
	assertEquals(fatPoints.contains(fatPoint),true);
	Set<TreeSet<String>> fatPoints2 = aSpace.fatPoints();
	assertEquals(fatPoints2.isEmpty(),true);
    }

    @Test
    public void testKolmogorovQuotient() {
	FiniteSpace<Integer> myKQ = someSpace.KolmogorovQuotient();
	Set<Integer> myKQ2PointSet = new TreeSet();
	BinaryRelation<Integer> myKQ2Relation = new BinaryRelation();
	myKQ2PointSet.addAll(Arrays.asList(1,4,5));
	myKQ2Relation.add(new ComparablePair(1,1));
	myKQ2Relation.add(new ComparablePair(1,4));
	myKQ2Relation.add(new ComparablePair(4,5));
	assertEquals(myKQ.getPointSet(),myKQ2PointSet);
	assertEquals(myKQ.getRelation().getPairs(),myKQ2Relation.getPairs());
    }

    @Test
    public void testDual() {
	FiniteSpace<Integer> myDual = someSpace.dual();
	Set<Integer> myDualPointSet = new TreeSet();
	BinaryRelation<Integer> myDualRelation = new BinaryRelation();
	myDualPointSet.addAll(Arrays.asList(1,2,3,4,5));
	myDualRelation.add(new ComparablePair(2,1));
	myDualRelation.add(new ComparablePair(3,2));
	myDualRelation.add(new ComparablePair(1,3));
	myDualRelation.add(new ComparablePair(4,3));
	myDualRelation.add(new ComparablePair(5,4));
	assertEquals(myDual.getPointSet(),myDualPointSet);
	assertEquals(myDual.getRelation().getPairs(),myDualRelation.getPairs());
    }

    @Test
    public void testHasseDiagram() {
	
	BinaryRelation<Integer> myHasseDiagram = someSpace.HasseDiagram();
	BinaryRelation<Integer> myHD = new BinaryRelation();
	myHD.add(new ComparablePair(1,4));
	myHD.add(new ComparablePair(4,5));
	assertEquals(myHasseDiagram.getPairs(),myHD.getPairs());

    }

    @Test
    public void testT0Space() {
	BinaryRelation<Integer> myHD = someSpace.HasseDiagram();
	//	System.out.println(myHD.getPairs());
	FiniteSpace<Integer> myT0Space = someSpace.T0Space();
	// System.out.println(myHD.getPairs());
	someSpace3.removePair(new ComparablePair(1,1));
	assertEquals(myT0Space.getPointSet(),someSpace3.getPointSet());
	assertEquals(myT0Space.getRelation().getPairs(),
		     someSpace3.getRelation().getPairs());
	assertEquals(myT0Space.getRelation().getPairs(),myHD.getPairs());
    }

    @Test
    public void testDimension() {
	int someDim = someSpace.dimension();
	assertEquals(someDim,2);
    }

    @Test
    public void testNeighbourhood() {
	FiniteSpace<Integer> U1 = someSpace.neighbourhood(1);
	assertEquals(U1.getPointSet(),someSpace.getPointSet());
	assertEquals(U1.getRelation().getPairs(),
		     someSpace.getRelation().getPairs());
    }

    @Test
    public void testPNeighbourhood() {
	FiniteSpace<Integer> U1Hat = someSpace.pNeighbourhood(1);
	someSpace.removePoint(1);
	assertEquals(U1Hat.getPointSet(),someSpace.getPointSet());
	boolean eq = U1Hat.getRelation().equals(someSpace.getRelation());
	//assertEquals(U1Hat.getRelation().getPairs(),
	//	     someSpace.getRelation().getPairs());
	assertEquals(eq,true);

	assertEquals(U3Hat.getPointSet(),U3HatPrime.getPointSet());
	assertEquals(U3Hat.getRelation().getPairs(),
		     U3HatPrime.getRelation().getPairs());

    }
    
    @Test
    public void testClosure() {
	FiniteSpace<Integer> F4 = someSpace.closure(4);
	someSpace.removePoint(5);
	assertEquals(F4.getPointSet(),someSpace.getPointSet());
	boolean eq = F4.getRelation().equals(someSpace.getRelation());
    }

    @Test
    public void testPClosure() {
	FiniteSpace<Integer> F4Hat = someSpace.pClosure(4);
	Set<Integer> points = new TreeSet();
	points.addAll(Arrays.asList(4,5));
	someSpace.removeAllPoint(points);
	boolean eq = F4Hat.equals(someSpace);
	assertEquals(eq,true);
    }

    @Test
    public void testKVertices() {
	Set<Integer> someKV = someSpace.KVertices();
	Set<Integer> five = new TreeSet();
	five.add(5);
	assertEquals(someKV,five);
    }

    @Test
    public void testKOpenPoints() {
	Set<Integer> someKO = someSpace.KOpenPoints();
	Set<Integer> one = new TreeSet();
	one.add(1);
	assertEquals(someKO,one);
    } 

    @After
    public void tearDown() {

    }
    
}
