package tests;

import org.junit.*;
import static org.junit.Assert.*;
import java.util.*;
import topology.*;

public class TestRelationCollection {
    
    BinaryRelation<Integer> ourRelation = new BinaryRelation();
    BinaryRelation<Integer> ourTC = new BinaryRelation();
    
    @Before
    public void setUp() {
	
	ourRelation.add(new ComparablePair(1,2));
	ourRelation.add(new ComparablePair(2,3));
	ourRelation.add(new ComparablePair(3,1));
	ourRelation.add(new ComparablePair(3,4));
	ourRelation.add(new ComparablePair(4,5));
	
	ourTC.addAll(ourRelation.getPairs());
	ourTC.add(new ComparablePair(1,1));
	ourTC.add(new ComparablePair(2,2));
	ourTC.add(new ComparablePair(3,3));
	ourTC.add(new ComparablePair(1,3));
	ourTC.add(new ComparablePair(1,4));
	ourTC.add(new ComparablePair(1,5));
	ourTC.add(new ComparablePair(2,1));
	ourTC.add(new ComparablePair(2,4));
	ourTC.add(new ComparablePair(2,5));
	ourTC.add(new ComparablePair(3,2));
	ourTC.add(new ComparablePair(3,5));
    }
    
    @Test
	public void testTransitiveClosure() {
	BinaryRelation<Integer> tc 
	    = RelationCollection.transitiveClosure(ourRelation);
	assertEquals(tc.getPairs(),ourTC.getPairs());
	//TopologyDemo.printRelation(tc);
    }

    @After
    public void tearDown() {

    }
    
}
